/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-cturtle-object-manipulation-0.2.4/debian/ros-cturtle-object-manipulation/opt/ros/cturtle/stacks/object_manipulation/object_manipulation_msgs/msg/Grasp.msg */
#ifndef OBJECT_MANIPULATION_MSGS_MESSAGE_GRASP_H
#define OBJECT_MANIPULATION_MSGS_MESSAGE_GRASP_H
#include <string>
#include <vector>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/message.h"
#include "ros/time.h"

#include "sensor_msgs/JointState.h"
#include "sensor_msgs/JointState.h"
#include "geometry_msgs/Pose.h"

namespace object_manipulation_msgs
{
template <class ContainerAllocator>
struct Grasp_ : public ros::Message
{
  typedef Grasp_<ContainerAllocator> Type;

  Grasp_()
  : pre_grasp_posture()
  , grasp_posture()
  , grasp_pose()
  {
  }

  Grasp_(const ContainerAllocator& _alloc)
  : pre_grasp_posture(_alloc)
  , grasp_posture(_alloc)
  , grasp_pose(_alloc)
  {
  }

  typedef  ::sensor_msgs::JointState_<ContainerAllocator>  _pre_grasp_posture_type;
   ::sensor_msgs::JointState_<ContainerAllocator>  pre_grasp_posture;

  typedef  ::sensor_msgs::JointState_<ContainerAllocator>  _grasp_posture_type;
   ::sensor_msgs::JointState_<ContainerAllocator>  grasp_posture;

  typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _grasp_pose_type;
   ::geometry_msgs::Pose_<ContainerAllocator>  grasp_pose;


private:
  static const char* __s_getDataType_() { return "object_manipulation_msgs/Grasp"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getDataType() { return __s_getDataType_(); }

  ROSCPP_DEPRECATED const std::string __getDataType() const { return __s_getDataType_(); }

private:
  static const char* __s_getMD5Sum_() { return "8f2b0aafb77b613c1da4d36487ec3427"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMD5Sum() { return __s_getMD5Sum_(); }

  ROSCPP_DEPRECATED const std::string __getMD5Sum() const { return __s_getMD5Sum_(); }

private:
  static const char* __s_getMessageDefinition_() { return "\n\
# The internal posture of the hand for the pre-grasp\n\
# only positions are used\n\
sensor_msgs/JointState pre_grasp_posture\n\
\n\
# The internal posture of the hand for the grasp\n\
# positions and efforts are used\n\
sensor_msgs/JointState grasp_posture\n\
\n\
# The position of the end-effector for the grasp relative to the object\n\
geometry_msgs/Pose grasp_pose\n\
\n\
\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: roslib/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMessageDefinition() { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED const std::string __getMessageDefinition() const { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED virtual uint8_t *serialize(uint8_t *write_ptr, uint32_t seq) const
  {
    ros::serialization::OStream stream(write_ptr, 1000000000);
    ros::serialization::serialize(stream, pre_grasp_posture);
    ros::serialization::serialize(stream, grasp_posture);
    ros::serialization::serialize(stream, grasp_pose);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    ros::serialization::IStream stream(read_ptr, 1000000000);
    ros::serialization::deserialize(stream, pre_grasp_posture);
    ros::serialization::deserialize(stream, grasp_posture);
    ros::serialization::deserialize(stream, grasp_pose);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint32_t serializationLength() const
  {
    uint32_t size = 0;
    size += ros::serialization::serializationLength(pre_grasp_posture);
    size += ros::serialization::serializationLength(grasp_posture);
    size += ros::serialization::serializationLength(grasp_pose);
    return size;
  }

  typedef boost::shared_ptr< ::object_manipulation_msgs::Grasp_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::object_manipulation_msgs::Grasp_<ContainerAllocator>  const> ConstPtr;
}; // struct Grasp
typedef  ::object_manipulation_msgs::Grasp_<std::allocator<void> > Grasp;

typedef boost::shared_ptr< ::object_manipulation_msgs::Grasp> GraspPtr;
typedef boost::shared_ptr< ::object_manipulation_msgs::Grasp const> GraspConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::object_manipulation_msgs::Grasp_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace object_manipulation_msgs

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator>
struct MD5Sum< ::object_manipulation_msgs::Grasp_<ContainerAllocator> > {
  static const char* value() 
  {
    return "8f2b0aafb77b613c1da4d36487ec3427";
  }

  static const char* value(const  ::object_manipulation_msgs::Grasp_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x8f2b0aafb77b613cULL;
  static const uint64_t static_value2 = 0x1da4d36487ec3427ULL;
};

template<class ContainerAllocator>
struct DataType< ::object_manipulation_msgs::Grasp_<ContainerAllocator> > {
  static const char* value() 
  {
    return "object_manipulation_msgs/Grasp";
  }

  static const char* value(const  ::object_manipulation_msgs::Grasp_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::object_manipulation_msgs::Grasp_<ContainerAllocator> > {
  static const char* value() 
  {
    return "\n\
# The internal posture of the hand for the pre-grasp\n\
# only positions are used\n\
sensor_msgs/JointState pre_grasp_posture\n\
\n\
# The internal posture of the hand for the grasp\n\
# positions and efforts are used\n\
sensor_msgs/JointState grasp_posture\n\
\n\
# The position of the end-effector for the grasp relative to the object\n\
geometry_msgs/Pose grasp_pose\n\
\n\
\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: roslib/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
";
  }

  static const char* value(const  ::object_manipulation_msgs::Grasp_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.pre_grasp_posture);
    stream.next(m.grasp_posture);
    stream.next(m.grasp_pose);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct Grasp_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::object_manipulation_msgs::Grasp_<ContainerAllocator> & v) 
  {
    s << indent << "pre_grasp_posture: ";
s << std::endl;
    Printer< ::sensor_msgs::JointState_<ContainerAllocator> >::stream(s, indent + "  ", v.pre_grasp_posture);
    s << indent << "grasp_posture: ";
s << std::endl;
    Printer< ::sensor_msgs::JointState_<ContainerAllocator> >::stream(s, indent + "  ", v.grasp_posture);
    s << indent << "grasp_pose: ";
s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.grasp_pose);
  }
};


} // namespace message_operations
} // namespace ros

#endif // OBJECT_MANIPULATION_MSGS_MESSAGE_GRASP_H

