/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-cturtle-object-manipulation-0.2.4/debian/ros-cturtle-object-manipulation/opt/ros/cturtle/stacks/object_manipulation/object_manipulation_msgs/msg/ManipulationResult.msg */
#ifndef OBJECT_MANIPULATION_MSGS_MESSAGE_MANIPULATIONRESULT_H
#define OBJECT_MANIPULATION_MSGS_MESSAGE_MANIPULATIONRESULT_H
#include <string>
#include <vector>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/message.h"
#include "ros/time.h"


namespace object_manipulation_msgs
{
template <class ContainerAllocator>
struct ManipulationResult_ : public ros::Message
{
  typedef ManipulationResult_<ContainerAllocator> Type;

  ManipulationResult_()
  : value(0)
  {
  }

  ManipulationResult_(const ContainerAllocator& _alloc)
  : value(0)
  {
  }

  typedef int32_t _value_type;
  int32_t value;

  enum { SUCCESS = 1 };
  enum { UNFEASIBLE = -1 };
  enum { FAILED = -2 };
  enum { ERROR = -3 };
  enum { ARM_MOVEMENT_PREVENTED = -4 };
  enum { LIFT_FAILED = -5 };
  enum { RETREAT_FAILED = -6 };

private:
  static const char* __s_getDataType_() { return "object_manipulation_msgs/ManipulationResult"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getDataType() { return __s_getDataType_(); }

  ROSCPP_DEPRECATED const std::string __getDataType() const { return __s_getDataType_(); }

private:
  static const char* __s_getMD5Sum_() { return "44af07f134ef2cd688c841bcdfd640e5"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMD5Sum() { return __s_getMD5Sum_(); }

  ROSCPP_DEPRECATED const std::string __getMD5Sum() const { return __s_getMD5Sum_(); }

private:
  static const char* __s_getMessageDefinition_() { return "# Result codes for manipulation tasks\n\
\n\
# task completed as expected\n\
# generally means you can proceed as planned\n\
int32 SUCCESS = 1\n\
\n\
# task not possible (e.g. out of reach or obstacles in the way)\n\
# generally means that the world was not disturbed, so you can try another task\n\
int32 UNFEASIBLE = -1\n\
\n\
# task was thought possible, but failed due to unexpected events during execution\n\
# it is likely that the world was disturbed, so you are encouraged to refresh\n\
# your sensed world model before proceeding to another task\n\
int32 FAILED = -2\n\
\n\
# a lower level error prevented task completion (e.g. joint controller not responding)\n\
# generally requires human attention\n\
int32 ERROR = -3\n\
\n\
# means that at some point during execution we ended up in a state that the collision-aware\n\
# arm navigation module will not move out of. The world was likely not disturbed, but you \n\
# probably need a new collision map to move the arm out of the stuck position\n\
int32 ARM_MOVEMENT_PREVENTED = -4\n\
\n\
# specific to grasp actions\n\
# the object was grasped successfully, but the lift attempt could not achieve the minimum lift distance requested\n\
# it is likely that the collision environment will see collisions between the hand/object and the support surface\n\
int32 LIFT_FAILED = -5\n\
\n\
# specific to place actions\n\
# the object was placed successfully, but the retreat attempt could not achieve the minimum retreat distance requested\n\
# it is likely that the collision environment will see collisions between the hand and the object\n\
int32 RETREAT_FAILED = -6\n\
\n\
# the actual value of this error code\n\
int32 value\n\
"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMessageDefinition() { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED const std::string __getMessageDefinition() const { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED virtual uint8_t *serialize(uint8_t *write_ptr, uint32_t seq) const
  {
    ros::serialization::OStream stream(write_ptr, 1000000000);
    ros::serialization::serialize(stream, value);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    ros::serialization::IStream stream(read_ptr, 1000000000);
    ros::serialization::deserialize(stream, value);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint32_t serializationLength() const
  {
    uint32_t size = 0;
    size += ros::serialization::serializationLength(value);
    return size;
  }

  typedef boost::shared_ptr< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator>  const> ConstPtr;
}; // struct ManipulationResult
typedef  ::object_manipulation_msgs::ManipulationResult_<std::allocator<void> > ManipulationResult;

typedef boost::shared_ptr< ::object_manipulation_msgs::ManipulationResult> ManipulationResultPtr;
typedef boost::shared_ptr< ::object_manipulation_msgs::ManipulationResult const> ManipulationResultConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace object_manipulation_msgs

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator>
struct MD5Sum< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> > {
  static const char* value() 
  {
    return "44af07f134ef2cd688c841bcdfd640e5";
  }

  static const char* value(const  ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x44af07f134ef2cd6ULL;
  static const uint64_t static_value2 = 0x88c841bcdfd640e5ULL;
};

template<class ContainerAllocator>
struct DataType< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> > {
  static const char* value() 
  {
    return "object_manipulation_msgs/ManipulationResult";
  }

  static const char* value(const  ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> > {
  static const char* value() 
  {
    return "# Result codes for manipulation tasks\n\
\n\
# task completed as expected\n\
# generally means you can proceed as planned\n\
int32 SUCCESS = 1\n\
\n\
# task not possible (e.g. out of reach or obstacles in the way)\n\
# generally means that the world was not disturbed, so you can try another task\n\
int32 UNFEASIBLE = -1\n\
\n\
# task was thought possible, but failed due to unexpected events during execution\n\
# it is likely that the world was disturbed, so you are encouraged to refresh\n\
# your sensed world model before proceeding to another task\n\
int32 FAILED = -2\n\
\n\
# a lower level error prevented task completion (e.g. joint controller not responding)\n\
# generally requires human attention\n\
int32 ERROR = -3\n\
\n\
# means that at some point during execution we ended up in a state that the collision-aware\n\
# arm navigation module will not move out of. The world was likely not disturbed, but you \n\
# probably need a new collision map to move the arm out of the stuck position\n\
int32 ARM_MOVEMENT_PREVENTED = -4\n\
\n\
# specific to grasp actions\n\
# the object was grasped successfully, but the lift attempt could not achieve the minimum lift distance requested\n\
# it is likely that the collision environment will see collisions between the hand/object and the support surface\n\
int32 LIFT_FAILED = -5\n\
\n\
# specific to place actions\n\
# the object was placed successfully, but the retreat attempt could not achieve the minimum retreat distance requested\n\
# it is likely that the collision environment will see collisions between the hand and the object\n\
int32 RETREAT_FAILED = -6\n\
\n\
# the actual value of this error code\n\
int32 value\n\
";
  }

  static const char* value(const  ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator> struct IsFixedSize< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> > : public TrueType {};
} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.value);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct ManipulationResult_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::object_manipulation_msgs::ManipulationResult_<ContainerAllocator> & v) 
  {
    s << indent << "value: ";
    Printer<int32_t>::stream(s, indent + "  ", v.value);
  }
};


} // namespace message_operations
} // namespace ros

#endif // OBJECT_MANIPULATION_MSGS_MESSAGE_MANIPULATIONRESULT_H

