/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-cturtle-object-manipulation-0.2.4/debian/ros-cturtle-object-manipulation/opt/ros/cturtle/stacks/object_manipulation/object_manipulation_msgs/msg/PickupGoal.msg */
#ifndef OBJECT_MANIPULATION_MSGS_MESSAGE_PICKUPGOAL_H
#define OBJECT_MANIPULATION_MSGS_MESSAGE_PICKUPGOAL_H
#include <string>
#include <vector>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/message.h"
#include "ros/time.h"

#include "object_manipulation_msgs/GraspableObject.h"
#include "object_manipulation_msgs/Grasp.h"
#include "object_manipulation_msgs/GripperTranslation.h"

namespace object_manipulation_msgs
{
template <class ContainerAllocator>
struct PickupGoal_ : public ros::Message
{
  typedef PickupGoal_<ContainerAllocator> Type;

  PickupGoal_()
  : arm_name()
  , target()
  , desired_grasps()
  , desired_approach_distance(0.0)
  , min_approach_distance(0.0)
  , lift()
  , collision_object_name()
  , collision_support_surface_name()
  , use_reactive_execution(false)
  , use_reactive_lift(false)
  {
  }

  PickupGoal_(const ContainerAllocator& _alloc)
  : arm_name(_alloc)
  , target(_alloc)
  , desired_grasps(_alloc)
  , desired_approach_distance(0.0)
  , min_approach_distance(0.0)
  , lift(_alloc)
  , collision_object_name(_alloc)
  , collision_support_surface_name(_alloc)
  , use_reactive_execution(false)
  , use_reactive_lift(false)
  {
  }

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _arm_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  arm_name;

  typedef  ::object_manipulation_msgs::GraspableObject_<ContainerAllocator>  _target_type;
   ::object_manipulation_msgs::GraspableObject_<ContainerAllocator>  target;

  typedef std::vector< ::object_manipulation_msgs::Grasp_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >::other >  _desired_grasps_type;
  std::vector< ::object_manipulation_msgs::Grasp_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >::other >  desired_grasps;

  typedef float _desired_approach_distance_type;
  float desired_approach_distance;

  typedef float _min_approach_distance_type;
  float min_approach_distance;

  typedef  ::object_manipulation_msgs::GripperTranslation_<ContainerAllocator>  _lift_type;
   ::object_manipulation_msgs::GripperTranslation_<ContainerAllocator>  lift;

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _collision_object_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  collision_object_name;

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _collision_support_surface_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  collision_support_surface_name;

  typedef uint8_t _use_reactive_execution_type;
  uint8_t use_reactive_execution;

  typedef uint8_t _use_reactive_lift_type;
  uint8_t use_reactive_lift;


  ROSCPP_DEPRECATED uint32_t get_desired_grasps_size() const { return (uint32_t)desired_grasps.size(); }
  ROSCPP_DEPRECATED void set_desired_grasps_size(uint32_t size) { desired_grasps.resize((size_t)size); }
  ROSCPP_DEPRECATED void get_desired_grasps_vec(std::vector< ::object_manipulation_msgs::Grasp_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >::other > & vec) const { vec = this->desired_grasps; }
  ROSCPP_DEPRECATED void set_desired_grasps_vec(const std::vector< ::object_manipulation_msgs::Grasp_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >::other > & vec) { this->desired_grasps = vec; }
private:
  static const char* __s_getDataType_() { return "object_manipulation_msgs/PickupGoal"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getDataType() { return __s_getDataType_(); }

  ROSCPP_DEPRECATED const std::string __getDataType() const { return __s_getDataType_(); }

private:
  static const char* __s_getMD5Sum_() { return "d6c446a3de863d74b78757f8419e12cb"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMD5Sum() { return __s_getMD5Sum_(); }

  ROSCPP_DEPRECATED const std::string __getMD5Sum() const { return __s_getMD5Sum_(); }

private:
  static const char* __s_getMessageDefinition_() { return "# An action for picking up an object\n\
\n\
# which arm to be used for grasping\n\
string arm_name\n\
\n\
# the object to be grasped\n\
GraspableObject target\n\
\n\
# a list of grasps to be used\n\
# if empty, the grasp executive will call one of its own planners\n\
Grasp[] desired_grasps\n\
\n\
# how far the pre-grasp should ideally be away from the grasp\n\
float32 desired_approach_distance\n\
\n\
# how much distance between pre-grasp and grasp must actually be feasible \n\
# for the grasp not to be rejected\n\
float32 min_approach_distance\n\
\n\
# how the object should be lifted after the grasp\n\
# the frame_id that this lift is specified in MUST be either the robot_frame \n\
# or the gripper_frame specified in your hand description file\n\
GripperTranslation lift\n\
\n\
# the name that the target object has in the collision map\n\
# can be left empty if no name is available\n\
string collision_object_name\n\
\n\
# the name that the support surface (e.g. table) has in the collision map\n\
# can be left empty if no name is available\n\
string collision_support_surface_name\n\
\n\
# whether reactive grasp execution using tactile sensors should be used\n\
bool use_reactive_execution\n\
\n\
# whether reactive object lifting based on tactile sensors should be used\n\
bool use_reactive_lift\n\
\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/GraspableObject\n\
# an object that the object_manipulator can work on\n\
\n\
# what type of object this is\n\
int32 DATABASE_MODEL = 1\n\
int32 POINT_CLUSTER = 2\n\
int32 type\n\
\n\
# the database model and its pose, if type==DATABASE_MODEL\n\
household_objects_database_msgs/DatabaseModelPose model_pose\n\
\n\
# the point cloud itself, if type==POINT_CLUSTER\n\
sensor_msgs/PointCloud cluster\n\
\n\
\n\
================================================================================\n\
MSG: household_objects_database_msgs/DatabaseModelPose\n\
# Informs that a specific model from the Model Database has been \n\
# identified at a certain location\n\
\n\
# the database id of the model\n\
int32 model_id\n\
# the pose that it can be found in\n\
geometry_msgs/PoseStamped pose\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: roslib/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: sensor_msgs/PointCloud\n\
#This message holds a collection of 3d points, plus optional additional information about each point.\n\
#Each Point32 should be interpreted as a 3d point in the frame given in the header\n\
\n\
Header header\n\
geometry_msgs/Point32[] points  #Array of 3d points\n\
ChannelFloat32[] channels       #Each channel should have the same number of elements as points array, and the data in each channel should correspond 1:1 with each point\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point32\n\
# This contains the position of a point in free space(with 32 bits of precision).\n\
# It is recommeded to use Point wherever possible instead of Point32.  \n\
# \n\
# This recommendation is to promote interoperability.  \n\
#\n\
# This message is designed to take up less space when sending\n\
# lots of points at once, as in the case of a PointCloud.  \n\
\n\
float32 x\n\
float32 y\n\
float32 z\n\
================================================================================\n\
MSG: sensor_msgs/ChannelFloat32\n\
#This message is used by the PointCloud message to hold optional data associated with each point in the cloud\n\
#The length of the values array should be the same as the length of the points array in the PointCloud, and each value should be associated with the corresponding point\n\
\n\
string name       #channel name should give semantics of the channel (e.g. \"intensity\" instead of \"value\")\n\
float32[] values  #values array should have same number of elements as the associated PointCloud\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/Grasp\n\
\n\
# The internal posture of the hand for the pre-grasp\n\
# only positions are used\n\
sensor_msgs/JointState pre_grasp_posture\n\
\n\
# The internal posture of the hand for the grasp\n\
# positions and efforts are used\n\
sensor_msgs/JointState grasp_posture\n\
\n\
# The position of the end-effector for the grasp relative to the object\n\
geometry_msgs/Pose grasp_pose\n\
\n\
\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/GripperTranslation\n\
# defines a translation for the gripper, used in pickup or place tasks\n\
# for example for lifting an object off a table or approaching the table for placing\n\
\n\
# the direction of the translation\n\
geometry_msgs/Vector3Stamped direction\n\
\n\
# the desired translation distance\n\
float32 desired_distance\n\
\n\
# the min distance that must be considered feasible before the\n\
# grasp is even attempted\n\
float32 min_distance\n\
================================================================================\n\
MSG: geometry_msgs/Vector3Stamped\n\
# This represents a Vector3 with reference coordinate frame and timestamp\n\
Header header\n\
Vector3 vector\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMessageDefinition() { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED const std::string __getMessageDefinition() const { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED virtual uint8_t *serialize(uint8_t *write_ptr, uint32_t seq) const
  {
    ros::serialization::OStream stream(write_ptr, 1000000000);
    ros::serialization::serialize(stream, arm_name);
    ros::serialization::serialize(stream, target);
    ros::serialization::serialize(stream, desired_grasps);
    ros::serialization::serialize(stream, desired_approach_distance);
    ros::serialization::serialize(stream, min_approach_distance);
    ros::serialization::serialize(stream, lift);
    ros::serialization::serialize(stream, collision_object_name);
    ros::serialization::serialize(stream, collision_support_surface_name);
    ros::serialization::serialize(stream, use_reactive_execution);
    ros::serialization::serialize(stream, use_reactive_lift);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    ros::serialization::IStream stream(read_ptr, 1000000000);
    ros::serialization::deserialize(stream, arm_name);
    ros::serialization::deserialize(stream, target);
    ros::serialization::deserialize(stream, desired_grasps);
    ros::serialization::deserialize(stream, desired_approach_distance);
    ros::serialization::deserialize(stream, min_approach_distance);
    ros::serialization::deserialize(stream, lift);
    ros::serialization::deserialize(stream, collision_object_name);
    ros::serialization::deserialize(stream, collision_support_surface_name);
    ros::serialization::deserialize(stream, use_reactive_execution);
    ros::serialization::deserialize(stream, use_reactive_lift);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint32_t serializationLength() const
  {
    uint32_t size = 0;
    size += ros::serialization::serializationLength(arm_name);
    size += ros::serialization::serializationLength(target);
    size += ros::serialization::serializationLength(desired_grasps);
    size += ros::serialization::serializationLength(desired_approach_distance);
    size += ros::serialization::serializationLength(min_approach_distance);
    size += ros::serialization::serializationLength(lift);
    size += ros::serialization::serializationLength(collision_object_name);
    size += ros::serialization::serializationLength(collision_support_surface_name);
    size += ros::serialization::serializationLength(use_reactive_execution);
    size += ros::serialization::serializationLength(use_reactive_lift);
    return size;
  }

  typedef boost::shared_ptr< ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::object_manipulation_msgs::PickupGoal_<ContainerAllocator>  const> ConstPtr;
}; // struct PickupGoal
typedef  ::object_manipulation_msgs::PickupGoal_<std::allocator<void> > PickupGoal;

typedef boost::shared_ptr< ::object_manipulation_msgs::PickupGoal> PickupGoalPtr;
typedef boost::shared_ptr< ::object_manipulation_msgs::PickupGoal const> PickupGoalConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace object_manipulation_msgs

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator>
struct MD5Sum< ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "d6c446a3de863d74b78757f8419e12cb";
  }

  static const char* value(const  ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0xd6c446a3de863d74ULL;
  static const uint64_t static_value2 = 0xb78757f8419e12cbULL;
};

template<class ContainerAllocator>
struct DataType< ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "object_manipulation_msgs/PickupGoal";
  }

  static const char* value(const  ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "# An action for picking up an object\n\
\n\
# which arm to be used for grasping\n\
string arm_name\n\
\n\
# the object to be grasped\n\
GraspableObject target\n\
\n\
# a list of grasps to be used\n\
# if empty, the grasp executive will call one of its own planners\n\
Grasp[] desired_grasps\n\
\n\
# how far the pre-grasp should ideally be away from the grasp\n\
float32 desired_approach_distance\n\
\n\
# how much distance between pre-grasp and grasp must actually be feasible \n\
# for the grasp not to be rejected\n\
float32 min_approach_distance\n\
\n\
# how the object should be lifted after the grasp\n\
# the frame_id that this lift is specified in MUST be either the robot_frame \n\
# or the gripper_frame specified in your hand description file\n\
GripperTranslation lift\n\
\n\
# the name that the target object has in the collision map\n\
# can be left empty if no name is available\n\
string collision_object_name\n\
\n\
# the name that the support surface (e.g. table) has in the collision map\n\
# can be left empty if no name is available\n\
string collision_support_surface_name\n\
\n\
# whether reactive grasp execution using tactile sensors should be used\n\
bool use_reactive_execution\n\
\n\
# whether reactive object lifting based on tactile sensors should be used\n\
bool use_reactive_lift\n\
\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/GraspableObject\n\
# an object that the object_manipulator can work on\n\
\n\
# what type of object this is\n\
int32 DATABASE_MODEL = 1\n\
int32 POINT_CLUSTER = 2\n\
int32 type\n\
\n\
# the database model and its pose, if type==DATABASE_MODEL\n\
household_objects_database_msgs/DatabaseModelPose model_pose\n\
\n\
# the point cloud itself, if type==POINT_CLUSTER\n\
sensor_msgs/PointCloud cluster\n\
\n\
\n\
================================================================================\n\
MSG: household_objects_database_msgs/DatabaseModelPose\n\
# Informs that a specific model from the Model Database has been \n\
# identified at a certain location\n\
\n\
# the database id of the model\n\
int32 model_id\n\
# the pose that it can be found in\n\
geometry_msgs/PoseStamped pose\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: roslib/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: sensor_msgs/PointCloud\n\
#This message holds a collection of 3d points, plus optional additional information about each point.\n\
#Each Point32 should be interpreted as a 3d point in the frame given in the header\n\
\n\
Header header\n\
geometry_msgs/Point32[] points  #Array of 3d points\n\
ChannelFloat32[] channels       #Each channel should have the same number of elements as points array, and the data in each channel should correspond 1:1 with each point\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point32\n\
# This contains the position of a point in free space(with 32 bits of precision).\n\
# It is recommeded to use Point wherever possible instead of Point32.  \n\
# \n\
# This recommendation is to promote interoperability.  \n\
#\n\
# This message is designed to take up less space when sending\n\
# lots of points at once, as in the case of a PointCloud.  \n\
\n\
float32 x\n\
float32 y\n\
float32 z\n\
================================================================================\n\
MSG: sensor_msgs/ChannelFloat32\n\
#This message is used by the PointCloud message to hold optional data associated with each point in the cloud\n\
#The length of the values array should be the same as the length of the points array in the PointCloud, and each value should be associated with the corresponding point\n\
\n\
string name       #channel name should give semantics of the channel (e.g. \"intensity\" instead of \"value\")\n\
float32[] values  #values array should have same number of elements as the associated PointCloud\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/Grasp\n\
\n\
# The internal posture of the hand for the pre-grasp\n\
# only positions are used\n\
sensor_msgs/JointState pre_grasp_posture\n\
\n\
# The internal posture of the hand for the grasp\n\
# positions and efforts are used\n\
sensor_msgs/JointState grasp_posture\n\
\n\
# The position of the end-effector for the grasp relative to the object\n\
geometry_msgs/Pose grasp_pose\n\
\n\
\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/GripperTranslation\n\
# defines a translation for the gripper, used in pickup or place tasks\n\
# for example for lifting an object off a table or approaching the table for placing\n\
\n\
# the direction of the translation\n\
geometry_msgs/Vector3Stamped direction\n\
\n\
# the desired translation distance\n\
float32 desired_distance\n\
\n\
# the min distance that must be considered feasible before the\n\
# grasp is even attempted\n\
float32 min_distance\n\
================================================================================\n\
MSG: geometry_msgs/Vector3Stamped\n\
# This represents a Vector3 with reference coordinate frame and timestamp\n\
Header header\n\
Vector3 vector\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
";
  }

  static const char* value(const  ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.arm_name);
    stream.next(m.target);
    stream.next(m.desired_grasps);
    stream.next(m.desired_approach_distance);
    stream.next(m.min_approach_distance);
    stream.next(m.lift);
    stream.next(m.collision_object_name);
    stream.next(m.collision_support_surface_name);
    stream.next(m.use_reactive_execution);
    stream.next(m.use_reactive_lift);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct PickupGoal_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::object_manipulation_msgs::PickupGoal_<ContainerAllocator> & v) 
  {
    s << indent << "arm_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.arm_name);
    s << indent << "target: ";
s << std::endl;
    Printer< ::object_manipulation_msgs::GraspableObject_<ContainerAllocator> >::stream(s, indent + "  ", v.target);
    s << indent << "desired_grasps[]" << std::endl;
    for (size_t i = 0; i < v.desired_grasps.size(); ++i)
    {
      s << indent << "  desired_grasps[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >::stream(s, indent + "    ", v.desired_grasps[i]);
    }
    s << indent << "desired_approach_distance: ";
    Printer<float>::stream(s, indent + "  ", v.desired_approach_distance);
    s << indent << "min_approach_distance: ";
    Printer<float>::stream(s, indent + "  ", v.min_approach_distance);
    s << indent << "lift: ";
s << std::endl;
    Printer< ::object_manipulation_msgs::GripperTranslation_<ContainerAllocator> >::stream(s, indent + "  ", v.lift);
    s << indent << "collision_object_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.collision_object_name);
    s << indent << "collision_support_surface_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.collision_support_surface_name);
    s << indent << "use_reactive_execution: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.use_reactive_execution);
    s << indent << "use_reactive_lift: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.use_reactive_lift);
  }
};


} // namespace message_operations
} // namespace ros

#endif // OBJECT_MANIPULATION_MSGS_MESSAGE_PICKUPGOAL_H

