/* Auto-generated by genmsg_cpp for file /tmp/buildd/ros-cturtle-object-manipulation-0.2.4/debian/ros-cturtle-object-manipulation/opt/ros/cturtle/stacks/object_manipulation/object_manipulation_msgs/msg/PlaceGoal.msg */
#ifndef OBJECT_MANIPULATION_MSGS_MESSAGE_PLACEGOAL_H
#define OBJECT_MANIPULATION_MSGS_MESSAGE_PLACEGOAL_H
#include <string>
#include <vector>
#include <ostream>
#include "ros/serialization.h"
#include "ros/builtin_message_traits.h"
#include "ros/message_operations.h"
#include "ros/message.h"
#include "ros/time.h"

#include "geometry_msgs/PoseStamped.h"
#include "object_manipulation_msgs/Grasp.h"
#include "object_manipulation_msgs/GripperTranslation.h"

namespace object_manipulation_msgs
{
template <class ContainerAllocator>
struct PlaceGoal_ : public ros::Message
{
  typedef PlaceGoal_<ContainerAllocator> Type;

  PlaceGoal_()
  : arm_name()
  , place_pose()
  , grasp()
  , desired_retreat_distance(0.0)
  , min_retreat_distance(0.0)
  , approach()
  , collision_object_name()
  , collision_support_surface_name()
  , use_reactive_place(false)
  , place_padding(0.0)
  {
  }

  PlaceGoal_(const ContainerAllocator& _alloc)
  : arm_name(_alloc)
  , place_pose(_alloc)
  , grasp(_alloc)
  , desired_retreat_distance(0.0)
  , min_retreat_distance(0.0)
  , approach(_alloc)
  , collision_object_name(_alloc)
  , collision_support_surface_name(_alloc)
  , use_reactive_place(false)
  , place_padding(0.0)
  {
  }

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _arm_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  arm_name;

  typedef  ::geometry_msgs::PoseStamped_<ContainerAllocator>  _place_pose_type;
   ::geometry_msgs::PoseStamped_<ContainerAllocator>  place_pose;

  typedef  ::object_manipulation_msgs::Grasp_<ContainerAllocator>  _grasp_type;
   ::object_manipulation_msgs::Grasp_<ContainerAllocator>  grasp;

  typedef float _desired_retreat_distance_type;
  float desired_retreat_distance;

  typedef float _min_retreat_distance_type;
  float min_retreat_distance;

  typedef  ::object_manipulation_msgs::GripperTranslation_<ContainerAllocator>  _approach_type;
   ::object_manipulation_msgs::GripperTranslation_<ContainerAllocator>  approach;

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _collision_object_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  collision_object_name;

  typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _collision_support_surface_name_type;
  std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  collision_support_surface_name;

  typedef uint8_t _use_reactive_place_type;
  uint8_t use_reactive_place;

  typedef double _place_padding_type;
  double place_padding;


private:
  static const char* __s_getDataType_() { return "object_manipulation_msgs/PlaceGoal"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getDataType() { return __s_getDataType_(); }

  ROSCPP_DEPRECATED const std::string __getDataType() const { return __s_getDataType_(); }

private:
  static const char* __s_getMD5Sum_() { return "7b1a1f48a3b720882c7ec7d68b7c6c4f"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMD5Sum() { return __s_getMD5Sum_(); }

  ROSCPP_DEPRECATED const std::string __getMD5Sum() const { return __s_getMD5Sum_(); }

private:
  static const char* __s_getMessageDefinition_() { return "\n\
# An action for placing an object\n\
\n\
# which arm to be used for grasping\n\
string arm_name\n\
\n\
# the desired pose of the object once it's been placed\n\
geometry_msgs/PoseStamped place_pose\n\
\n\
# the grasp that has been executed on this object\n\
Grasp grasp\n\
\n\
# how far the retreat should ideally be away from the place location\n\
float32 desired_retreat_distance\n\
\n\
# the min distance between the retreat and the place location that must actually be feasible \n\
# for the place not to be rejected\n\
float32 min_retreat_distance\n\
\n\
# how the place location should be approached\n\
# the frame_id that this lift is specified in MUST be either the robot_frame \n\
# or the gripper_frame specified in your hand description file\n\
GripperTranslation approach\n\
\n\
# the name that the target object has in the collision map\n\
# can be left empty if no name is available\n\
string collision_object_name\n\
\n\
# the name that the support surface (e.g. table) has in the collision map\n\
# can be left empty if no name is available\n\
string collision_support_surface_name\n\
\n\
# whether reactive placing based on tactile sensors should be used\n\
bool use_reactive_place\n\
\n\
# how much the object should be padded by when deciding if the grasp\n\
# location is freasible or not\n\
float64 place_padding\n\
\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: roslib/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/Grasp\n\
\n\
# The internal posture of the hand for the pre-grasp\n\
# only positions are used\n\
sensor_msgs/JointState pre_grasp_posture\n\
\n\
# The internal posture of the hand for the grasp\n\
# positions and efforts are used\n\
sensor_msgs/JointState grasp_posture\n\
\n\
# The position of the end-effector for the grasp relative to the object\n\
geometry_msgs/Pose grasp_pose\n\
\n\
\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/GripperTranslation\n\
# defines a translation for the gripper, used in pickup or place tasks\n\
# for example for lifting an object off a table or approaching the table for placing\n\
\n\
# the direction of the translation\n\
geometry_msgs/Vector3Stamped direction\n\
\n\
# the desired translation distance\n\
float32 desired_distance\n\
\n\
# the min distance that must be considered feasible before the\n\
# grasp is even attempted\n\
float32 min_distance\n\
================================================================================\n\
MSG: geometry_msgs/Vector3Stamped\n\
# This represents a Vector3 with reference coordinate frame and timestamp\n\
Header header\n\
Vector3 vector\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
"; }
public:
  ROSCPP_DEPRECATED static const std::string __s_getMessageDefinition() { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED const std::string __getMessageDefinition() const { return __s_getMessageDefinition_(); }

  ROSCPP_DEPRECATED virtual uint8_t *serialize(uint8_t *write_ptr, uint32_t seq) const
  {
    ros::serialization::OStream stream(write_ptr, 1000000000);
    ros::serialization::serialize(stream, arm_name);
    ros::serialization::serialize(stream, place_pose);
    ros::serialization::serialize(stream, grasp);
    ros::serialization::serialize(stream, desired_retreat_distance);
    ros::serialization::serialize(stream, min_retreat_distance);
    ros::serialization::serialize(stream, approach);
    ros::serialization::serialize(stream, collision_object_name);
    ros::serialization::serialize(stream, collision_support_surface_name);
    ros::serialization::serialize(stream, use_reactive_place);
    ros::serialization::serialize(stream, place_padding);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    ros::serialization::IStream stream(read_ptr, 1000000000);
    ros::serialization::deserialize(stream, arm_name);
    ros::serialization::deserialize(stream, place_pose);
    ros::serialization::deserialize(stream, grasp);
    ros::serialization::deserialize(stream, desired_retreat_distance);
    ros::serialization::deserialize(stream, min_retreat_distance);
    ros::serialization::deserialize(stream, approach);
    ros::serialization::deserialize(stream, collision_object_name);
    ros::serialization::deserialize(stream, collision_support_surface_name);
    ros::serialization::deserialize(stream, use_reactive_place);
    ros::serialization::deserialize(stream, place_padding);
    return stream.getData();
  }

  ROSCPP_DEPRECATED virtual uint32_t serializationLength() const
  {
    uint32_t size = 0;
    size += ros::serialization::serializationLength(arm_name);
    size += ros::serialization::serializationLength(place_pose);
    size += ros::serialization::serializationLength(grasp);
    size += ros::serialization::serializationLength(desired_retreat_distance);
    size += ros::serialization::serializationLength(min_retreat_distance);
    size += ros::serialization::serializationLength(approach);
    size += ros::serialization::serializationLength(collision_object_name);
    size += ros::serialization::serializationLength(collision_support_surface_name);
    size += ros::serialization::serializationLength(use_reactive_place);
    size += ros::serialization::serializationLength(place_padding);
    return size;
  }

  typedef boost::shared_ptr< ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator>  const> ConstPtr;
}; // struct PlaceGoal
typedef  ::object_manipulation_msgs::PlaceGoal_<std::allocator<void> > PlaceGoal;

typedef boost::shared_ptr< ::object_manipulation_msgs::PlaceGoal> PlaceGoalPtr;
typedef boost::shared_ptr< ::object_manipulation_msgs::PlaceGoal const> PlaceGoalConstPtr;


template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const  ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> & v)
{
  ros::message_operations::Printer< ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> >::stream(s, "", v);
  return s;}

} // namespace object_manipulation_msgs

namespace ros
{
namespace message_traits
{
template<class ContainerAllocator>
struct MD5Sum< ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "7b1a1f48a3b720882c7ec7d68b7c6c4f";
  }

  static const char* value(const  ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> &) { return value(); } 
  static const uint64_t static_value1 = 0x7b1a1f48a3b72088ULL;
  static const uint64_t static_value2 = 0x2c7ec7d68b7c6c4fULL;
};

template<class ContainerAllocator>
struct DataType< ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "object_manipulation_msgs/PlaceGoal";
  }

  static const char* value(const  ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> &) { return value(); } 
};

template<class ContainerAllocator>
struct Definition< ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> > {
  static const char* value() 
  {
    return "\n\
# An action for placing an object\n\
\n\
# which arm to be used for grasping\n\
string arm_name\n\
\n\
# the desired pose of the object once it's been placed\n\
geometry_msgs/PoseStamped place_pose\n\
\n\
# the grasp that has been executed on this object\n\
Grasp grasp\n\
\n\
# how far the retreat should ideally be away from the place location\n\
float32 desired_retreat_distance\n\
\n\
# the min distance between the retreat and the place location that must actually be feasible \n\
# for the place not to be rejected\n\
float32 min_retreat_distance\n\
\n\
# how the place location should be approached\n\
# the frame_id that this lift is specified in MUST be either the robot_frame \n\
# or the gripper_frame specified in your hand description file\n\
GripperTranslation approach\n\
\n\
# the name that the target object has in the collision map\n\
# can be left empty if no name is available\n\
string collision_object_name\n\
\n\
# the name that the support surface (e.g. table) has in the collision map\n\
# can be left empty if no name is available\n\
string collision_support_surface_name\n\
\n\
# whether reactive placing based on tactile sensors should be used\n\
bool use_reactive_place\n\
\n\
# how much the object should be padded by when deciding if the grasp\n\
# location is freasible or not\n\
float64 place_padding\n\
\n\
\n\
================================================================================\n\
MSG: geometry_msgs/PoseStamped\n\
# A Pose with reference coordinate frame and timestamp\n\
Header header\n\
Pose pose\n\
\n\
================================================================================\n\
MSG: roslib/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/Grasp\n\
\n\
# The internal posture of the hand for the pre-grasp\n\
# only positions are used\n\
sensor_msgs/JointState pre_grasp_posture\n\
\n\
# The internal posture of the hand for the grasp\n\
# positions and efforts are used\n\
sensor_msgs/JointState grasp_posture\n\
\n\
# The position of the end-effector for the grasp relative to the object\n\
geometry_msgs/Pose grasp_pose\n\
\n\
\n\
================================================================================\n\
MSG: sensor_msgs/JointState\n\
# This is a message that holds data to describe the state of a set of torque controlled joints. \n\
#\n\
# The state of each joint (revolute or prismatic) is defined by:\n\
#  * the position of the joint (rad or m),\n\
#  * the velocity of the joint (rad/s or m/s) and \n\
#  * the effort that is applied in the joint (Nm or N).\n\
#\n\
# Each joint is uniquely identified by its name\n\
# The header specifies the time at which the joint states were recorded. All the joint states\n\
# in one message have to be recorded at the same time.\n\
#\n\
# This message consists of a multiple arrays, one for each part of the joint state. \n\
# The goal is to make each of the fields optional. When e.g. your joints have no\n\
# effort associated with them, you can leave the effort array empty. \n\
#\n\
# All arrays in this message should have the same size, or be empty.\n\
# This is the only way to uniquely associate the joint name with the correct\n\
# states.\n\
\n\
\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
================================================================================\n\
MSG: object_manipulation_msgs/GripperTranslation\n\
# defines a translation for the gripper, used in pickup or place tasks\n\
# for example for lifting an object off a table or approaching the table for placing\n\
\n\
# the direction of the translation\n\
geometry_msgs/Vector3Stamped direction\n\
\n\
# the desired translation distance\n\
float32 desired_distance\n\
\n\
# the min distance that must be considered feasible before the\n\
# grasp is even attempted\n\
float32 min_distance\n\
================================================================================\n\
MSG: geometry_msgs/Vector3Stamped\n\
# This represents a Vector3 with reference coordinate frame and timestamp\n\
Header header\n\
Vector3 vector\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
";
  }

  static const char* value(const  ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> &) { return value(); } 
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

template<class ContainerAllocator> struct Serializer< ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> >
{
  template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
  {
    stream.next(m.arm_name);
    stream.next(m.place_pose);
    stream.next(m.grasp);
    stream.next(m.desired_retreat_distance);
    stream.next(m.min_retreat_distance);
    stream.next(m.approach);
    stream.next(m.collision_object_name);
    stream.next(m.collision_support_surface_name);
    stream.next(m.use_reactive_place);
    stream.next(m.place_padding);
  }

  ROS_DECLARE_ALLINONE_SERIALIZER;
}; // struct PlaceGoal_
} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const  ::object_manipulation_msgs::PlaceGoal_<ContainerAllocator> & v) 
  {
    s << indent << "arm_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.arm_name);
    s << indent << "place_pose: ";
s << std::endl;
    Printer< ::geometry_msgs::PoseStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.place_pose);
    s << indent << "grasp: ";
s << std::endl;
    Printer< ::object_manipulation_msgs::Grasp_<ContainerAllocator> >::stream(s, indent + "  ", v.grasp);
    s << indent << "desired_retreat_distance: ";
    Printer<float>::stream(s, indent + "  ", v.desired_retreat_distance);
    s << indent << "min_retreat_distance: ";
    Printer<float>::stream(s, indent + "  ", v.min_retreat_distance);
    s << indent << "approach: ";
s << std::endl;
    Printer< ::object_manipulation_msgs::GripperTranslation_<ContainerAllocator> >::stream(s, indent + "  ", v.approach);
    s << indent << "collision_object_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.collision_object_name);
    s << indent << "collision_support_surface_name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.collision_support_surface_name);
    s << indent << "use_reactive_place: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.use_reactive_place);
    s << indent << "place_padding: ";
    Printer<double>::stream(s, indent + "  ", v.place_padding);
  }
};


} // namespace message_operations
} // namespace ros

#endif // OBJECT_MANIPULATION_MSGS_MESSAGE_PLACEGOAL_H

