"""autogenerated by genmsg_py from GraspableObject.msg. Do not edit."""
import roslib.message
import struct

import sensor_msgs.msg
import geometry_msgs.msg
import roslib.msg
import household_objects_database_msgs.msg

class GraspableObject(roslib.message.Message):
  _md5sum = "edf4905ce1ee40987aae7385fe8518d6"
  _type = "object_manipulation_msgs/GraspableObject"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# an object that the object_manipulator can work on

# what type of object this is
int32 DATABASE_MODEL = 1
int32 POINT_CLUSTER = 2
int32 type

# the database model and its pose, if type==DATABASE_MODEL
household_objects_database_msgs/DatabaseModelPose model_pose

# the point cloud itself, if type==POINT_CLUSTER
sensor_msgs/PointCloud cluster


================================================================================
MSG: household_objects_database_msgs/DatabaseModelPose
# Informs that a specific model from the Model Database has been 
# identified at a certain location

# the database id of the model
int32 model_id
# the pose that it can be found in
geometry_msgs/PoseStamped pose

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/PointCloud
#This message holds a collection of 3d points, plus optional additional information about each point.
#Each Point32 should be interpreted as a 3d point in the frame given in the header

Header header
geometry_msgs/Point32[] points  #Array of 3d points
ChannelFloat32[] channels       #Each channel should have the same number of elements as points array, and the data in each channel should correspond 1:1 with each point

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/ChannelFloat32
#This message is used by the PointCloud message to hold optional data associated with each point in the cloud
#The length of the values array should be the same as the length of the points array in the PointCloud, and each value should be associated with the corresponding point

string name       #channel name should give semantics of the channel (e.g. "intensity" instead of "value")
float32[] values  #values array should have same number of elements as the associated PointCloud

"""
  # Pseudo-constants
  DATABASE_MODEL = 1
  POINT_CLUSTER = 2

  __slots__ = ['type','model_pose','cluster']
  _slot_types = ['int32','household_objects_database_msgs/DatabaseModelPose','sensor_msgs/PointCloud']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       type,model_pose,cluster
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GraspableObject, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.type is None:
        self.type = 0
      if self.model_pose is None:
        self.model_pose = household_objects_database_msgs.msg.DatabaseModelPose()
      if self.cluster is None:
        self.cluster = sensor_msgs.msg.PointCloud()
    else:
      self.type = 0
      self.model_pose = household_objects_database_msgs.msg.DatabaseModelPose()
      self.cluster = sensor_msgs.msg.PointCloud()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_2i3I.pack(_x.type, _x.model_pose.model_id, _x.model_pose.pose.header.seq, _x.model_pose.pose.header.stamp.secs, _x.model_pose.pose.header.stamp.nsecs))
      _x = self.model_pose.pose.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.model_pose.pose.pose.position.x, _x.model_pose.pose.pose.position.y, _x.model_pose.pose.pose.position.z, _x.model_pose.pose.pose.orientation.x, _x.model_pose.pose.pose.orientation.y, _x.model_pose.pose.pose.orientation.z, _x.model_pose.pose.pose.orientation.w, _x.cluster.header.seq, _x.cluster.header.stamp.secs, _x.cluster.header.stamp.nsecs))
      _x = self.cluster.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.cluster.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.cluster.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.cluster.channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.cluster.channels:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.values))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.model_pose is None:
        self.model_pose = household_objects_database_msgs.msg.DatabaseModelPose()
      if self.cluster is None:
        self.cluster = sensor_msgs.msg.PointCloud()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.type, _x.model_pose.model_id, _x.model_pose.pose.header.seq, _x.model_pose.pose.header.stamp.secs, _x.model_pose.pose.header.stamp.nsecs,) = _struct_2i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.model_pose.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.model_pose.pose.pose.position.x, _x.model_pose.pose.pose.position.y, _x.model_pose.pose.pose.position.z, _x.model_pose.pose.pose.orientation.x, _x.model_pose.pose.pose.orientation.y, _x.model_pose.pose.pose.orientation.z, _x.model_pose.pose.pose.orientation.w, _x.cluster.header.seq, _x.cluster.header.stamp.secs, _x.cluster.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.cluster.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cluster.points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.cluster.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cluster.channels = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = struct.unpack(pattern, str[start:end])
        self.cluster.channels.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_2i3I.pack(_x.type, _x.model_pose.model_id, _x.model_pose.pose.header.seq, _x.model_pose.pose.header.stamp.secs, _x.model_pose.pose.header.stamp.nsecs))
      _x = self.model_pose.pose.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.model_pose.pose.pose.position.x, _x.model_pose.pose.pose.position.y, _x.model_pose.pose.pose.position.z, _x.model_pose.pose.pose.orientation.x, _x.model_pose.pose.pose.orientation.y, _x.model_pose.pose.pose.orientation.z, _x.model_pose.pose.pose.orientation.w, _x.cluster.header.seq, _x.cluster.header.stamp.secs, _x.cluster.header.stamp.nsecs))
      _x = self.cluster.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.cluster.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.cluster.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.cluster.channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.cluster.channels:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.values.tostring())
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.model_pose is None:
        self.model_pose = household_objects_database_msgs.msg.DatabaseModelPose()
      if self.cluster is None:
        self.cluster = sensor_msgs.msg.PointCloud()
      end = 0
      _x = self
      start = end
      end += 20
      (_x.type, _x.model_pose.model_id, _x.model_pose.pose.header.seq, _x.model_pose.pose.header.stamp.secs, _x.model_pose.pose.header.stamp.nsecs,) = _struct_2i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.model_pose.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.model_pose.pose.pose.position.x, _x.model_pose.pose.pose.position.y, _x.model_pose.pose.pose.position.z, _x.model_pose.pose.pose.orientation.x, _x.model_pose.pose.pose.orientation.y, _x.model_pose.pose.pose.orientation.z, _x.model_pose.pose.pose.orientation.w, _x.cluster.header.seq, _x.cluster.header.stamp.secs, _x.cluster.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.cluster.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cluster.points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.cluster.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cluster.channels = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.cluster.channels.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3f = struct.Struct("<3f")
_struct_7d3I = struct.Struct("<7d3I")
_struct_2i3I = struct.Struct("<2i3I")
