"""autogenerated by genmsg_py from GripperTranslation.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg

class GripperTranslation(roslib.message.Message):
  _md5sum = "b53bc0ad0f717cdec3b0e42dec300121"
  _type = "object_manipulation_msgs/GripperTranslation"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance
================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['direction','desired_distance','min_distance']
  _slot_types = ['geometry_msgs/Vector3Stamped','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       direction,desired_distance,min_distance
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GripperTranslation, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.direction is None:
        self.direction = geometry_msgs.msg.Vector3Stamped()
      if self.desired_distance is None:
        self.desired_distance = 0.
      if self.min_distance is None:
        self.min_distance = 0.
    else:
      self.direction = geometry_msgs.msg.Vector3Stamped()
      self.desired_distance = 0.
      self.min_distance = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.direction.header.seq, _x.direction.header.stamp.secs, _x.direction.header.stamp.nsecs))
      _x = self.direction.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d2f.pack(_x.direction.vector.x, _x.direction.vector.y, _x.direction.vector.z, _x.desired_distance, _x.min_distance))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.direction is None:
        self.direction = geometry_msgs.msg.Vector3Stamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.direction.header.seq, _x.direction.header.stamp.secs, _x.direction.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.direction.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.direction.vector.x, _x.direction.vector.y, _x.direction.vector.z, _x.desired_distance, _x.min_distance,) = _struct_3d2f.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.direction.header.seq, _x.direction.header.stamp.secs, _x.direction.header.stamp.nsecs))
      _x = self.direction.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d2f.pack(_x.direction.vector.x, _x.direction.vector.y, _x.direction.vector.z, _x.desired_distance, _x.min_distance))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.direction is None:
        self.direction = geometry_msgs.msg.Vector3Stamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.direction.header.seq, _x.direction.header.stamp.secs, _x.direction.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.direction.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.direction.vector.x, _x.direction.vector.y, _x.direction.vector.z, _x.desired_distance, _x.min_distance,) = _struct_3d2f.unpack(str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_3I = struct.Struct("<3I")
_struct_3d2f = struct.Struct("<3d2f")
