"""autogenerated by genmsg_py from PickupGoal.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import sensor_msgs.msg
import object_manipulation_msgs.msg
import roslib.msg
import household_objects_database_msgs.msg

class PickupGoal(roslib.message.Message):
  _md5sum = "d6c446a3de863d74b78757f8419e12cb"
  _type = "object_manipulation_msgs/PickupGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# An action for picking up an object

# which arm to be used for grasping
string arm_name

# the object to be grasped
GraspableObject target

# a list of grasps to be used
# if empty, the grasp executive will call one of its own planners
Grasp[] desired_grasps

# how far the pre-grasp should ideally be away from the grasp
float32 desired_approach_distance

# how much distance between pre-grasp and grasp must actually be feasible 
# for the grasp not to be rejected
float32 min_approach_distance

# how the object should be lifted after the grasp
# the frame_id that this lift is specified in MUST be either the robot_frame 
# or the gripper_frame specified in your hand description file
GripperTranslation lift

# the name that the target object has in the collision map
# can be left empty if no name is available
string collision_object_name

# the name that the support surface (e.g. table) has in the collision map
# can be left empty if no name is available
string collision_support_surface_name

# whether reactive grasp execution using tactile sensors should be used
bool use_reactive_execution

# whether reactive object lifting based on tactile sensors should be used
bool use_reactive_lift


================================================================================
MSG: object_manipulation_msgs/GraspableObject
# an object that the object_manipulator can work on

# what type of object this is
int32 DATABASE_MODEL = 1
int32 POINT_CLUSTER = 2
int32 type

# the database model and its pose, if type==DATABASE_MODEL
household_objects_database_msgs/DatabaseModelPose model_pose

# the point cloud itself, if type==POINT_CLUSTER
sensor_msgs/PointCloud cluster


================================================================================
MSG: household_objects_database_msgs/DatabaseModelPose
# Informs that a specific model from the Model Database has been 
# identified at a certain location

# the database id of the model
int32 model_id
# the pose that it can be found in
geometry_msgs/PoseStamped pose

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/PointCloud
#This message holds a collection of 3d points, plus optional additional information about each point.
#Each Point32 should be interpreted as a 3d point in the frame given in the header

Header header
geometry_msgs/Point32[] points  #Array of 3d points
ChannelFloat32[] channels       #Each channel should have the same number of elements as points array, and the data in each channel should correspond 1:1 with each point

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/ChannelFloat32
#This message is used by the PointCloud message to hold optional data associated with each point in the cloud
#The length of the values array should be the same as the length of the points array in the PointCloud, and each value should be associated with the corresponding point

string name       #channel name should give semantics of the channel (e.g. "intensity" instead of "value")
float32[] values  #values array should have same number of elements as the associated PointCloud

================================================================================
MSG: object_manipulation_msgs/Grasp

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp relative to the object
geometry_msgs/Pose grasp_pose


================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: object_manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance
================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"""
  __slots__ = ['arm_name','target','desired_grasps','desired_approach_distance','min_approach_distance','lift','collision_object_name','collision_support_surface_name','use_reactive_execution','use_reactive_lift']
  _slot_types = ['string','object_manipulation_msgs/GraspableObject','object_manipulation_msgs/Grasp[]','float32','float32','object_manipulation_msgs/GripperTranslation','string','string','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       arm_name,target,desired_grasps,desired_approach_distance,min_approach_distance,lift,collision_object_name,collision_support_surface_name,use_reactive_execution,use_reactive_lift
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(PickupGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.arm_name is None:
        self.arm_name = ''
      if self.target is None:
        self.target = object_manipulation_msgs.msg.GraspableObject()
      if self.desired_grasps is None:
        self.desired_grasps = []
      if self.desired_approach_distance is None:
        self.desired_approach_distance = 0.
      if self.min_approach_distance is None:
        self.min_approach_distance = 0.
      if self.lift is None:
        self.lift = object_manipulation_msgs.msg.GripperTranslation()
      if self.collision_object_name is None:
        self.collision_object_name = ''
      if self.collision_support_surface_name is None:
        self.collision_support_surface_name = ''
      if self.use_reactive_execution is None:
        self.use_reactive_execution = False
      if self.use_reactive_lift is None:
        self.use_reactive_lift = False
    else:
      self.arm_name = ''
      self.target = object_manipulation_msgs.msg.GraspableObject()
      self.desired_grasps = []
      self.desired_approach_distance = 0.
      self.min_approach_distance = 0.
      self.lift = object_manipulation_msgs.msg.GripperTranslation()
      self.collision_object_name = ''
      self.collision_support_surface_name = ''
      self.use_reactive_execution = False
      self.use_reactive_lift = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self.arm_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2i3I.pack(_x.target.type, _x.target.model_pose.model_id, _x.target.model_pose.pose.header.seq, _x.target.model_pose.pose.header.stamp.secs, _x.target.model_pose.pose.header.stamp.nsecs))
      _x = self.target.model_pose.pose.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.target.model_pose.pose.pose.position.x, _x.target.model_pose.pose.pose.position.y, _x.target.model_pose.pose.pose.position.z, _x.target.model_pose.pose.pose.orientation.x, _x.target.model_pose.pose.pose.orientation.y, _x.target.model_pose.pose.pose.orientation.z, _x.target.model_pose.pose.pose.orientation.w, _x.target.cluster.header.seq, _x.target.cluster.header.stamp.secs, _x.target.cluster.header.stamp.nsecs))
      _x = self.target.cluster.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.target.cluster.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.target.cluster.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.target.cluster.channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.target.cluster.channels:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.values))
      length = len(self.desired_grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.desired_grasps:
        _v1 = val1.pre_grasp_posture
        _v2 = _v1.header
        buff.write(_struct_I.pack(_v2.seq))
        _v3 = _v2.stamp
        _x = _v3
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v2.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v1.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v1.name:
          length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v1.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v1.position))
        length = len(_v1.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v1.velocity))
        length = len(_v1.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v1.effort))
        _v4 = val1.grasp_posture
        _v5 = _v4.header
        buff.write(_struct_I.pack(_v5.seq))
        _v6 = _v5.stamp
        _x = _v6
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v5.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v4.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v4.name:
          length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v4.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v4.position))
        length = len(_v4.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v4.velocity))
        length = len(_v4.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v4.effort))
        _v7 = val1.grasp_pose
        _v8 = _v7.position
        _x = _v8
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v9 = _v7.orientation
        _x = _v9
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_2f3I.pack(_x.desired_approach_distance, _x.min_approach_distance, _x.lift.direction.header.seq, _x.lift.direction.header.stamp.secs, _x.lift.direction.header.stamp.nsecs))
      _x = self.lift.direction.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d2f.pack(_x.lift.direction.vector.x, _x.lift.direction.vector.y, _x.lift.direction.vector.z, _x.lift.desired_distance, _x.lift.min_distance))
      _x = self.collision_object_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.collision_support_surface_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2B.pack(_x.use_reactive_execution, _x.use_reactive_lift))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.target is None:
        self.target = object_manipulation_msgs.msg.GraspableObject()
      if self.lift is None:
        self.lift = object_manipulation_msgs.msg.GripperTranslation()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.arm_name = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.target.type, _x.target.model_pose.model_id, _x.target.model_pose.pose.header.seq, _x.target.model_pose.pose.header.stamp.secs, _x.target.model_pose.pose.header.stamp.nsecs,) = _struct_2i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target.model_pose.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.target.model_pose.pose.pose.position.x, _x.target.model_pose.pose.pose.position.y, _x.target.model_pose.pose.pose.position.z, _x.target.model_pose.pose.pose.orientation.x, _x.target.model_pose.pose.pose.orientation.y, _x.target.model_pose.pose.pose.orientation.z, _x.target.model_pose.pose.pose.orientation.w, _x.target.cluster.header.seq, _x.target.cluster.header.stamp.secs, _x.target.cluster.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target.cluster.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.target.cluster.points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.target.cluster.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.target.cluster.channels = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = struct.unpack(pattern, str[start:end])
        self.target.cluster.channels.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.desired_grasps = []
      for i in xrange(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v10 = val1.pre_grasp_posture
        _v11 = _v10.header
        start = end
        end += 4
        (_v11.seq,) = _struct_I.unpack(str[start:end])
        _v12 = _v11.stamp
        _x = _v12
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v11.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v10.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val3 = str[start:end]
          _v10.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v10.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v10.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v10.effort = struct.unpack(pattern, str[start:end])
        _v13 = val1.grasp_posture
        _v14 = _v13.header
        start = end
        end += 4
        (_v14.seq,) = _struct_I.unpack(str[start:end])
        _v15 = _v14.stamp
        _x = _v15
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v14.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v13.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val3 = str[start:end]
          _v13.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v13.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v13.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v13.effort = struct.unpack(pattern, str[start:end])
        _v16 = val1.grasp_pose
        _v17 = _v16.position
        _x = _v17
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v18 = _v16.orientation
        _x = _v18
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.desired_grasps.append(val1)
      _x = self
      start = end
      end += 20
      (_x.desired_approach_distance, _x.min_approach_distance, _x.lift.direction.header.seq, _x.lift.direction.header.stamp.secs, _x.lift.direction.header.stamp.nsecs,) = _struct_2f3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.lift.direction.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.lift.direction.vector.x, _x.lift.direction.vector.y, _x.lift.direction.vector.z, _x.lift.desired_distance, _x.lift.min_distance,) = _struct_3d2f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.collision_object_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.collision_support_surface_name = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.use_reactive_execution, _x.use_reactive_lift,) = _struct_2B.unpack(str[start:end])
      self.use_reactive_execution = bool(self.use_reactive_execution)
      self.use_reactive_lift = bool(self.use_reactive_lift)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self.arm_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2i3I.pack(_x.target.type, _x.target.model_pose.model_id, _x.target.model_pose.pose.header.seq, _x.target.model_pose.pose.header.stamp.secs, _x.target.model_pose.pose.header.stamp.nsecs))
      _x = self.target.model_pose.pose.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7d3I.pack(_x.target.model_pose.pose.pose.position.x, _x.target.model_pose.pose.pose.position.y, _x.target.model_pose.pose.pose.position.z, _x.target.model_pose.pose.pose.orientation.x, _x.target.model_pose.pose.pose.orientation.y, _x.target.model_pose.pose.pose.orientation.z, _x.target.model_pose.pose.pose.orientation.w, _x.target.cluster.header.seq, _x.target.cluster.header.stamp.secs, _x.target.cluster.header.stamp.nsecs))
      _x = self.target.cluster.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.target.cluster.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.target.cluster.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.target.cluster.channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.target.cluster.channels:
        _x = val1.name
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.values.tostring())
      length = len(self.desired_grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.desired_grasps:
        _v19 = val1.pre_grasp_posture
        _v20 = _v19.header
        buff.write(_struct_I.pack(_v20.seq))
        _v21 = _v20.stamp
        _x = _v21
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v20.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v19.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v19.name:
          length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v19.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v19.position.tostring())
        length = len(_v19.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v19.velocity.tostring())
        length = len(_v19.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v19.effort.tostring())
        _v22 = val1.grasp_posture
        _v23 = _v22.header
        buff.write(_struct_I.pack(_v23.seq))
        _v24 = _v23.stamp
        _x = _v24
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v23.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v22.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v22.name:
          length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v22.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v22.position.tostring())
        length = len(_v22.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v22.velocity.tostring())
        length = len(_v22.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v22.effort.tostring())
        _v25 = val1.grasp_pose
        _v26 = _v25.position
        _x = _v26
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v27 = _v25.orientation
        _x = _v27
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
      _x = self
      buff.write(_struct_2f3I.pack(_x.desired_approach_distance, _x.min_approach_distance, _x.lift.direction.header.seq, _x.lift.direction.header.stamp.secs, _x.lift.direction.header.stamp.nsecs))
      _x = self.lift.direction.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d2f.pack(_x.lift.direction.vector.x, _x.lift.direction.vector.y, _x.lift.direction.vector.z, _x.lift.desired_distance, _x.lift.min_distance))
      _x = self.collision_object_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.collision_support_surface_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2B.pack(_x.use_reactive_execution, _x.use_reactive_lift))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.target is None:
        self.target = object_manipulation_msgs.msg.GraspableObject()
      if self.lift is None:
        self.lift = object_manipulation_msgs.msg.GripperTranslation()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.arm_name = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.target.type, _x.target.model_pose.model_id, _x.target.model_pose.pose.header.seq, _x.target.model_pose.pose.header.stamp.secs, _x.target.model_pose.pose.header.stamp.nsecs,) = _struct_2i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target.model_pose.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.target.model_pose.pose.pose.position.x, _x.target.model_pose.pose.pose.position.y, _x.target.model_pose.pose.pose.position.z, _x.target.model_pose.pose.pose.orientation.x, _x.target.model_pose.pose.pose.orientation.y, _x.target.model_pose.pose.pose.orientation.z, _x.target.model_pose.pose.pose.orientation.w, _x.target.cluster.header.seq, _x.target.cluster.header.stamp.secs, _x.target.cluster.header.stamp.nsecs,) = _struct_7d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target.cluster.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.target.cluster.points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.target.cluster.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.target.cluster.channels = []
      for i in xrange(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.target.cluster.channels.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.desired_grasps = []
      for i in xrange(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v28 = val1.pre_grasp_posture
        _v29 = _v28.header
        start = end
        end += 4
        (_v29.seq,) = _struct_I.unpack(str[start:end])
        _v30 = _v29.stamp
        _x = _v30
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v29.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v28.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val3 = str[start:end]
          _v28.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v28.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v28.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v28.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v31 = val1.grasp_posture
        _v32 = _v31.header
        start = end
        end += 4
        (_v32.seq,) = _struct_I.unpack(str[start:end])
        _v33 = _v32.stamp
        _x = _v33
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v32.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v31.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          val3 = str[start:end]
          _v31.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v31.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v31.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v31.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v34 = val1.grasp_pose
        _v35 = _v34.position
        _x = _v35
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v36 = _v34.orientation
        _x = _v36
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        self.desired_grasps.append(val1)
      _x = self
      start = end
      end += 20
      (_x.desired_approach_distance, _x.min_approach_distance, _x.lift.direction.header.seq, _x.lift.direction.header.stamp.secs, _x.lift.direction.header.stamp.nsecs,) = _struct_2f3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.lift.direction.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.lift.direction.vector.x, _x.lift.direction.vector.y, _x.lift.direction.vector.z, _x.lift.desired_distance, _x.lift.min_distance,) = _struct_3d2f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.collision_object_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.collision_support_surface_name = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.use_reactive_execution, _x.use_reactive_lift,) = _struct_2B.unpack(str[start:end])
      self.use_reactive_execution = bool(self.use_reactive_execution)
      self.use_reactive_lift = bool(self.use_reactive_lift)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_2f3I = struct.Struct("<2f3I")
_struct_2i3I = struct.Struct("<2i3I")
_struct_3d2f = struct.Struct("<3d2f")
_struct_7d3I = struct.Struct("<7d3I")
_struct_2B = struct.Struct("<2B")
_struct_4d = struct.Struct("<4d")
_struct_3f = struct.Struct("<3f")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
